/*test append-child attribute X-NODEREF*/
function appendChild returns int (err-num as int):
   def var hDoc as handle.
   def var hDoc2 as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hTemp as handle.
   def var res as logical init false.
   def var c as character init false.
   create x-document hDoc.
   create x-document hDoc2.
   create x-noderef hChild.
   create x-noderef hTemp.

   hDoc:append-child(hRoot) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4065
            then message "Unexpected error append-child: " error-status:get-number(1) " " error-status:get-message(1).

   create x-noderef hRoot.
   hDoc:append-child(hRoot) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9102
               then message "Unexpected error append-child: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:create-node(hRoot,"root","element").

   hDoc2:append-child(hRoot) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9082
                  then message "Unexpected error append-child: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:create-node(hChild,"root1","element").
   hDoc:create-node(hTemp,"root2","element").
   hDoc:append-child(hRoot).

   hDoc:append-child(hTemp) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9082
                  then message "Unexpected error append-child: " error-status:get-number(1) " " error-status:get-message(1).

   hRoot:append-child(hChild).
   hChild:append-child(hRoot) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9082
                  then message "Unexpected error append-child: " error-status:get-number(1) " " error-status:get-message(1).

   if hRoot:num-children <> 1
         then message "Unexpected error append-child: child is not added".

   hDoc:create-node(hChild,"root21","text").
   hDoc:create-node(hTemp,"root2","attribute").
   hRoot:append-child(hChild).
   hChild:append-child(hChild) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9082
                  then message "Unexpected error append-child: " error-status:get-number(1) " " error-status:get-message(1).

   return 0.
end.

appendChild(-1).

/*test getAttributeNames attribute X-NODEREF*/
function getAttributeNames returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hText as handle.
   def var res as logical init false.
   def var l as logical.
   def var c as character.
   create x-document hDoc.
   create x-noderef hRoot.
   create x-noderef hText.

   hRoot:attribute-names no-error.

   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9102
                  then message "Unexpected error getAttributeNames: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:create-node(hRoot,"root","element").
   hDoc:create-node(hText, ?,"text").
   hDoc:append-child(hRoot).
   hRoot:set-attribute("atr1","data1").
   hRoot:set-attribute("atr2","data2").

   if not hRoot:attribute-names eq "atr1 atr2" then "Unexpected error: attribute-names".

   hRoot:attribute-names = "Asd" no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4052
                  then message "Unexpected error getAttributeNames: " error-status:get-number(1) " " error-status:get-message(1).

   if not hText:attribute-names eq "" then "Unexpected error: attribute-names".

   return 0.
end.

getAttributeNames(-1).

/*test clone-node attribute X-NODEREF*/
function cloneNode returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hTemp as handle.
   def var hCloneNode as handle.
   def var res as logical init false.
   def var l as logical.
   def var c as character.
   create x-document hDoc.
   create x-noderef hRoot.
   create x-noderef hChild.
   create x-noderef hTemp.

   hDoc:create-node(hRoot,"root","element").
   hDoc:create-node(hChild,"child","element").
   hDoc:append-child(hRoot).
   hRoot:append-child(hChild).

   hRoot:clone-node(hCloneNode, ?) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4065
                        then message "Unexpected error clone-node: " error-status:get-number(1) " " error-status:get-message(1).

   create x-noderef hCloneNode.

   hCloneNode:clone-node(hTemp, true) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9102
                        then message "Unexpected error clone-node: " error-status:get-number(1) " " error-status:get-message(1).

   l = hRoot:clone-node(hCloneNode, true) no-error.

   if hRoot:name <> hCloneNode:name or not l then message "error clone-node".

   return 0.
end.

cloneNode(-1).

/*test create-node method*/
function nodeCreation returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hNode1 as handle.
   def var res as logical init false.
   def var c as character.

   create x-document hDoc.
   create x-noderef hRoot.

   hNode1 = ?.
   hDoc:create-node(hNode1,"root","element") no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4065
            then message "Unexpected error name: " error-status:get-number(1) " " error-status:get-message(1).

   res = hDoc:create-node(hRoot,"root","eLEMENT").

   res = false.
   res = hDoc:create-node(hRoot,"root","eLEMEN1T") no-error.

   if error-status:error or error-status:num-messages <> 2 or not error-status:get-number(1) eq 9171
                     or not error-status:get-number(2) eq 4065 or res
         then message "Unexpected create-node error code2: " error-status:get-number(1) " " error-status:get-message(1).

   res = false.
   c = ?.
   res = hDoc:create-node(hRoot,"root",c).

   if hRoot:subtype <> "element" then "Unexpected create-node error: should be element node created".

   res = false.

   res = hDoc:create-node(hRoot,c,"ELEMENT") no-error.

   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9082 or res
         then message "Unexpected create-node error code4: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:create-node(hRoot,"<",c) no-error.
   /*An invalid character was specified*/
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9082 or res
         then message "Unexpected create-node error code4: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:create-node(hRoot,"<","text").

   return 0.
end.

nodeCreation(-1).

/*test create-node-namespace X-NODEREF*/
function createNodeNamespace returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hTemp as handle.
   def var hTemp2 as handle.

   def var i  as int no-undo.

   def var res as logical init false.
   def var c as character init false.
   create x-document hDoc.
   create x-noderef hChild.
   create x-noderef hTemp.
   create x-noderef hTemp2.

   hDoc:create-node-namespace(hRoot, "aaa", "ttt:el", "element") no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4065
      then message "Unexpected error create-node-namespace 1: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:create-node-namespace(hRoot, "aaa", "ttt:el", ?) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4065
      then message "Unexpected error create-node-namespace 1: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:create-node-namespace(hRoot, "aaa", "ttt:el", "element1") no-error.
   if error-status:error or error-status:num-messages <> 2 or not error-status:get-number(1) eq 9171 or not error-status:get-number(2) eq 4065
         then message "Unexpected create-node-namespace error 2: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:create-node-namespace(hRoot, "aaa", "ttt:el", "text") no-error.
   if error-status:error or error-status:num-messages <> 2 or not error-status:get-number(1) eq 9171 or not error-status:get-number(2) eq 4065
            then message "Unexpected create-node-namespace error 2: " error-status:get-number(1) " " error-status:get-message(1).

   create x-noderef hRoot.

   hDoc:create-node-namespace(hRoot, "aaa", "ttt:el", "text") no-error.
   if error-status:error or error-status:num-messages <> 2 or not error-status:get-number(1) eq 9171 or not error-status:get-number(2) eq 4065
         then message "Unexpected create-node-namespace error 2: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:create-node-namespace(hRoot, "a", "&:el", "element") no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9082
         then message "Unexpected error create-node-namespace 3: " error-status:get-number(1) " " error-status:get-message(1).

   if not hDoc:create-node-namespace(hRoot, ?, "el", "element")
      or not hDoc:create-node-namespace(hRoot, ?, "el", "attribute") then message "Unexpected error create-node-namespace 4".

   hDoc:create-node-namespace(hRoot, "", "dd:aa", "element") no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9082
         then message "Unexpected error create-node-namespace 5: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:create-node-namespace(hRoot, "unique", "dd:aa", "element").

   if hRoot:namespace-prefix <> "dd" then message "Unexpected error create-node-namespace 6".
   return 0.
end.

createNodeNamespace(-1).


/*test deleteNode attribute X-NODEREF*/
function deleteNode returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var res as logical init false.
   def var l as logical.
   def var c as character.
   create x-document hDoc.
   create x-noderef hRoot.
   create x-noderef hChild.

   l = hRoot:delete-node no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9102 and l
                     then message "Unexpected error delete-node: " error-status:get-number(1) " " error-status:get-message(1).


   hDoc:create-node(hRoot,"root","element").
   hDoc:append-child(hRoot).
   if not hRoot:delete-node then "Unexpected error: delete-node".

   l = hRoot:delete-node no-error.  /*node has been already deleted*/

   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9102 and l
                  then message "Unexpected error delete-node: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:create-node(hRoot,"root","element").
   hDoc:create-node(hChild,"child","element").
   hRoot:append-child(hChild).
   hChild:delete-node.

   if hRoot:num-children <> 0 then message "Unexpected error num-children".

   return 0.
end.

deleteNode(-1).


/*test get-document-element method*/
function getDocumentElement returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hNode1 as handle.
   def var hNode2 as handle.
   def var res as logical init false.
   def var c as character.

   create x-document hDoc.
   create x-noderef hRoot.
   create x-noderef hNode1.


   hDoc:create-node(hNode1,"hNode1","element") no-error.
   res = hDoc:get-document-element(hNode1).
   if not res then "Unexpected error: get-document-element".
   hNode1:name no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9102
               then message "Unexpected error get-document-element: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:create-node(hRoot,"root","element") no-error.

   hDoc:append-child(hRoot).

   hDoc:get-document-element(hNode2) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4065
            then message "Unexpected error get-document-element: " error-status:get-number(1) " " error-status:get-message(1).

   /*check here that hRoot has been changed and now doesn't contains old node*/
   res = hDoc:get-document-element(hNode1).
   if hNode1:name <> "root"
      then message "Unexpected error get-document-element2".

   return 0.
end.

getDocumentElement(-1).



/*test GET-ATTRIBUTE attribute X-NODEREF*/
function getAttribute returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var res as logical init false.
   def var c as character init false.
   create x-document hDoc.
   create x-noderef hRoot.
   create x-noderef hChild.

   hRoot:get-attribute("test") no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9102
         then message "Unexpected error get-attribute: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:create-node(hRoot,"root","element").
   hDoc:create-node(hChild,"","text").
   hDoc:append-child(hRoot).
   hRoot:append-child(hChild).

   hRoot:get-attribute(?) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4065
         then message "Unexpected error get-attribute: " error-status:get-number(1) " " error-status:get-message(1).

   hChild:get-attribute("test").
   hRoot:set-attribute("test", "data").
   c = hRoot:get-attribute("test").
   if c <> "data" then message "Unexpected error get-attribute".
   if hChild:get-attribute("test") <> "" then message "Unexpected error get-attribute".

   return 0.
end.

getAttribute(-1).



/*test get-attribute-node attribute X-NODEREF*/
function getAttributeNode returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hAttr as handle.
   def var hTemp as handle.
   def var res as logical init false.
   def var c as character init false.
   create x-document hDoc.
   create x-noderef hRoot.


   create x-noderef hTemp.

   hRoot:get-attribute-node(hAttr, "ttt") no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4065
      then message "Unexpected error get-attribute-node: " error-status:get-number(1) " " error-status:get-message(1).

   create x-noderef hAttr.

   hRoot:get-attribute-node(hDoc, "ttt") no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4065
      then message "Unexpected error get-attribute-node: " error-status:get-number(1) " " error-status:get-message(1).

   hRoot:get-attribute-node(hAttr, "ttt") no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9102
      then message "Unexpected error get-attribute-node: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:create-node(hRoot,"root","element").

   hRoot:get-attribute-node(hChild, "ttt") no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4065
      then message "Unexpected error get-attribute-node: " error-status:get-number(1) " " error-status:get-message(1).

   create x-noderef hChild.
   hDoc:create-node(hChild,"","text").
   hDoc:create-node(hAttr,"ttt","attribute").
   hDoc:append-child(hRoot).
   hRoot:append-child(hChild).

   hRoot:set-attribute-node(hAttr).
   c = ?.
   hRoot:get-attribute-node(hTemp, c) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4065
      then message "Unexpected error get-attribute-node: " error-status:get-number(1) " " error-status:get-message(1).

   hChild:get-attribute-node(hTemp, "ttt") no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9082
      then message "Unexpected error get-attribute-node: " error-status:get-number(1) " " error-status:get-message(1).

   hRoot:get-attribute-node(hTemp, "ttt").
   if error-status:error then message "Unexpected error get-attribute-node".

   if hAttr:name <> hTemp:name then message "Unexpected error get-attribute-node".

   return 0.
end.

getAttributeNode(-1).



/*test get-child attribute X-NODEREF*/
function getChild returns int (err-num as int):
   def var hDoc as handle.
   def var hDoc2 as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hTemp as handle.
   def var res as logical init false.
   def var c as character init false.
   def var i as integer init 1.
   create x-document hDoc.
   create x-document hDoc2.
   create x-noderef hChild.

   create x-noderef hRoot.

   hDoc:create-node(hRoot,"root","element").
   hDoc:create-node(hChild,"root1","element").
   hDoc:append-child(hRoot).
   hRoot:append-child(hChild).

   hRoot:get-child(hTemp, 1) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4065
            then message "Unexpected error get-child: " error-status:get-number(1) " " error-status:get-message(1).

   create x-noderef hTemp.
   i = ?.
   hRoot:get-child(hTemp, i) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4065
            then message "Unexpected error get-child: " error-status:get-number(1) " " error-status:get-message(1).

   hTemp:get-child(hTemp, 1) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9102
            then message "Unexpected error get-child: " error-status:get-number(1) " " error-status:get-message(1).

   hRoot:get-child(hTemp, 10) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9082
            then message "Unexpected error get-child: " error-status:get-number(1) " " error-status:get-message(1).

   hRoot:get-child(hTemp, 1).

   if hChild:name <> hTemp:name
         then message "Unexpected error get-child: nodes are not equals".

   return 0.
end.

getChild(-1).


/*test child-num attribute X-NODEREF*/
function getChildNum returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hTemp as handle.
   def var res as logical init false.
   def var c as character init false.
   create x-document hDoc.
   create x-noderef hChild.
   create x-noderef hTemp.
   create x-noderef hRoot.

   hRoot:child-num no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9102
         then message "Unexpected error child-num: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:create-node(hRoot,"root","element").

   if hRoot:child-num <> 1 then message "Unexpected error child-num".

   hRoot:child-num = 123 no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4052
            then message "Unexpected error child-num: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:create-node(hTemp,"hTemp","element").
   hDoc:create-node(hChild,"","text").
   hDoc:append-child(hRoot).
   hRoot:append-child(hChild).
   hRoot:append-child(hTemp).

   if hRoot:child-num <> 1 or hTemp:child-num <> 2 or hDoc:child-num <> ? then message "Unexpected error child-num".
   if hDoc:child-num <> ? then message "Unexpected error child-num: Document should return unknown value".
   return 0.
end.

getChildNum(-1).


/*test encoding attribute*/
function getEncoding returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hNode1 as handle.
   def var res as logical init false.
   def var c as character.
   def var unk as character.

   create x-document hDoc.

   c = hDoc:encoding.
   if not c eq "" then "Unexpected error: encoding doesn't equals empty string".
   hDoc:encoding = "utf8".
   if not c eq "utf8" then "Unexpected error: encoding doesn't equals utf8".

   hDoc:encoding = "some_unknown_encoding".
   if not c eq "some_unknown_encoding" then "Unexpected error: encoding doesn't equals utf8".

   return 0.
end.

getEncoding(-1).


/*test num-children attribute X-NODEREF*/
function getNumChildren returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hTemp as handle.
   def var res as logical init false.
   def var c as character init false.
   create x-document hDoc.
   create x-noderef hRoot.
   create x-noderef hChild.
   create x-noderef hTemp.

   hRoot:num-children no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9102
         then message "Unexpected error num-children: " error-status:get-number(1) " " error-status:get-message(1).


   hDoc:create-node(hRoot,"root","element").
   hDoc:create-node(hTemp,"hTemp","element").
   hDoc:create-node(hChild,"","text").
   hDoc:append-child(hRoot).
   hRoot:append-child(hChild).
   hRoot:append-child(hTemp).

   if hRoot:num-children <> 2 or hDoc:num-children <> 1 or hChild:num-children <> 0 then message "Unexpected error num-children".

   hRoot:num-children = 2 no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4052
            then message "Unexpected error num-children: " error-status:get-number(1) " " error-status:get-message(1).

   return 0.
end.

getNumChildren(-1).



/*test get-parent attribute X-NODEREF*/
function getParent returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hWork as handle.
   def var hTemp as handle.
   def var res as logical init false.
   def var l as logical.
   def var c as character.
   create x-document hDoc.
   create x-noderef hRoot.

   create x-noderef hTemp.
   create x-noderef hChild.

   hDoc:create-node(hRoot,"root","element").
   hDoc:create-node(hChild,"child","element").
   hDoc:append-child(hRoot).

   hChild:get-parent(hWork) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4065
                        then message "Unexpected error get-parent: " error-status:get-number(1) " " error-status:get-message(1).
   create x-noderef hWork.

   hWork:get-parent(hTemp) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9102
                        then message "Unexpected error get-parent: " error-status:get-number(1) " " error-status:get-message(1).

   hChild:get-parent(hWork).
   hWork:subtype no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9102
                     then message "Unexpected error get-parent: " error-status:get-number(1) " " error-status:get-message(1).
   hRoot:append-child(hChild).
   hChild:get-parent(hWork).

   hWork:subtype.

   if hWork:name <> hRoot:name then message "error get-parent".

   hRoot:remove-child(hChild).

   hChild:get-parent(hWork). /*hWork should be unknown */

   hWork:subtype no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9102
                     then message "Unexpected error get-parent: " error-status:get-number(1) " " error-status:get-message(1).

   return 0.
end.

getParent(-1).


/*test subtype attribute X-NODEREF*/
function getSubType returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hTemp as handle.
   def var res as logical init false.
   def var c as character init false.
   create x-document hDoc.
   create x-noderef hRoot.
   create x-noderef hChild.
   create x-noderef hTemp.

   hDoc:create-node(hRoot,"root","element").
   hDoc:create-node(hChild,"","text").
   hDoc:append-child(hRoot).
   hRoot:append-child(hChild).
   hTemp:subtype no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9102
         then message "Unexpected error subtype: " error-status:get-number(1) " " error-status:get-message(1).

   if hRoot:subtype <> "ELEMENT" or hChild:subtype <> "TEXT" or hDoc:subtype <> "DOCUMENT" then message "Unexpected error subtype".

   hRoot:subtype = "asd" no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4052
            then message "Unexpected error subtype: " error-status:get-number(1) " " error-status:get-message(1).

   return 0.
end.

getSubType(-1).


/* Test is not working, because of incorrect work of handle attribute*/
function handleTest returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var res as logical init false.
   def var l as logical.
   def var c as character.
   create x-document hDoc.
   create x-noderef hRoot.

   hRoot:handle = hDoc no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4052
            then message "Unexpected error handle: " error-status:get-number(1) " " error-status:get-message(1).

   if not hRoot:handle eq hRoot then message "Unexpected error: hRoot".
  return 0.
end.

handleTest(-1).


/*test import-node X-NODEREF*/
function importNode returns int (err-num as int):
   def var hDoc as handle.
   def var hDoc2 as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hTemp as handle.
   def var hTemp2 as handle.

   def var i  as int no-undo.

   def var res as logical init false.
   def var c as character init false.
   create x-document hDoc.
   create x-document hDoc2.
   create x-noderef hChild.
   create x-noderef hTemp.
   create x-noderef hRoot.


   hDoc2:create-node(hRoot, "root", "element").
   res = ?.
   hDoc:import-node(hTemp2, hRoot, res) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4065
         then message "Unexpected error import-node case 1: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:import-node(hRoot, hTemp2, res) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4065
         then message "Unexpected error import-node case 2: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:import-node(hRoot, hRoot, res) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9102
         then message "Unexpected error import-node case 3: " error-status:get-number(1) " " error-status:get-message(1).

   /* hRoot become invalid*/
   hRoot:name no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9102
         then message "Unexpected error import-node case 4: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc2:create-node(hRoot, "root", "element").
   create x-noderef hTemp2.
   hDoc:import-node(hTemp2, hRoot, res).

   hDoc:append-child(hTemp2).

   return 0.
end.

importNode(-1).
