/*test initialize-document-type X-NODEREF*/
function initializeDocumentType returns int (err-num as int):
   def var hDoc as handle.
   def var hDoc2 as handle.
   def var hRoot as handle.

   def var i  as int no-undo.

   def var res as logical init false.
   def var c as character init false.
   def var namespaceURI as character.
   def var rootNodeName as character.
   def var systemId as character.
   def var publicId as character.
   create x-document hDoc.
   create x-document hDoc2.
   create x-noderef hRoot.

   namespaceURI = "http://www.w3.org/1999/xhtml".
   rootNodeName = "h:html".
   systemId = "http://www.w3.org/TR/html4/strict.dtd".
   publicId = "-//W3C//DTD HTML 4.01//EN".

   c = ?.
   /*hDoc:initialize-document-type("namespace-uri", "root-node-name", "public-id", "system-id").*/
   hDoc:initialize-document-type("namespace-uri", ?, "public-id", "system-id") no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 4065
      then message "Unexpected error initialize-document-type 1: " error-status:get-number(1) " " error-status:get-message(1).

   res = hDoc:initialize-document-type(?, "root-node-name", ?, ?) no-error.
   if not res
      then message "Unexpected error initialize-document-type 2: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc2:initialize-document-type(namespaceURI, ":asd", publicId, systemId) no-error.
   if error-status:error or error-status:num-messages <> 1 or not error-status:get-number(1) eq 9082
      then message "Unexpected error initialize-document-type 1: " error-status:get-number(1) " " error-status:get-message(1).

   res = hDoc:initialize-document-type(namespaceURI, rootNodeName, publicId, systemId).
   if not res
      then message "Unexpected error initialize-document-type 3: " error-status:get-number(1) " " error-status:get-message(1).

   if hDoc:num-children <> 2
            then message "Unexpected error initialize-document-type 4: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:get-document-element(hRoot).
   if not hRoot:name eq rootNodeName or not hRoot:namespace-prefix eq "h"
            then message "Unexpected error initialize-document-type 5: " error-status:get-number(1) " " error-status:get-message(1).

   if not hDoc:public-id eq publicId or not hDoc:system-id eq systemId
            then message "Unexpected error initialize-document-type 6: " error-status:get-number(1) " " error-status:get-message(1).

   return 0.
end.

initializeDocumentType(-1).